/**
 * @file
 * README file for Google Cloud Storage.
 */
 
CONTENTS
--------

1.  Introduction
2.  Installation
3.  Configuration
4.  Module Detail
5.  Troubleshooting

## Introduction
 
Google Cloud Storage allows you to replace the local file system with  [Google Storage](https://developers.google.com/storage/). Files uploaded into  Google Cloud Storage.

Google Cloud Storage can be used as the default file system, or configure each file/image field to use a specific bucket. 

## INSTALLATION
Install the module and enable it according to Drupal standards.

The module's configuration pages reside at:
- admin/config/media/gcs

The module's permissions are found at:
- admin/people/permissions

## REQUIREMENTS

Need to Upload Service Account Json File
-   Open the project, go to  `APIs & auth`  >  `Credentials`
-   Click on  `Create new Client ID`, and select  `Service account`  edit any service and  then click on  `Create key`  to download `.json file`. and for `Service Account Private Key Id from`  to generate key after .json file created 
- .json file upload on Service Account Json File filed
- Client ID add from OAuth 2.0 Client IDs in client id
- Service Account Private Key Id from key generated id
- Client Email from `Service Accounts`   email id
- Add your `Bucket Name`
- Add `Folder Name` in  bucket  for easily filter 
 
Google Cloud Storage requires:
- Libraries API
- XAutoLoad
- Google API PHP Client Library
(https://github.com/google/google-api-php-client)


## CONFIGURATION

Google Cloud Storage's configuration section is located at:

- Admin > Configuration > Media > Google Cloud Storage

This section allows the admin to configure settings that pertain to the
connection details and configuration of the module.
Download the two dependent modules and install them according to Drupal
standards. Download the Google API PHP library and place it in the
following location sites/all/libraries/google-api-php-client.
The main Google_Client.php file should be found at
sites/all/libraries/google-api-php-client/src/Google/Client.php.

## Module Detail

Once the module is installed and permissions are configured, the administrator
should configure the GCS. Once the configuration options are inputted,
the admin can test the connection to ensure that the site is able to connect
to the Google bucket.

If the connection succeeds, the administrator can then select the File System
default download method to be the GCS. This makes the entire file system
upload and download all files to / from the Google Bucket.

As well, the admin can set the default download option on each file and image
field. This sets the specific field to use or not use the GCS as the
default upload and download method.

## Troubleshooting

* If the "Test Connection" admin button fails check the following:
- Check all details of the configuration and ensure they are correct
- Ensure the .json  key is saved on the file system
